searchData={"items":[{"type":"module","title":"Resourceful","doc":"Resourceful is a library intended to provide a common interface for  generic\noperations and representations for resources in an edge-facing API. These\ninclude:\n\n  * Filtering\n  * Introspection\n  * Pagination\n  * Representation\n  * Searching\n  * Sorting\n  * Input validation\n  * Type checking\n\nIts defaults are intended to be appropriate for web-based APIs. For instance,\nthe filters are significantly simpler than SQL. The format for items such as\nsorting and pagination are also intended for easy adaptation to URL query\nstrings. (The entire library is opinionated toward this use case.)\n\nResources themselves are expected to be maps or structs.","ref":"Resourceful.html"},{"type":"module","title":"Resourceful.Collection","doc":"Provides a common interface for querying and retrieving collections.\n\nDeligated modules designed to interact directly with the underlying data or\ndata sources must return alls of resources. For instance, when using `Ecto`,\nthis module should return alls of structs or maps and not queries that have\nnot been executed yet.","ref":"Resourceful.Collection.html"},{"type":"module","title":"Data Sources - Resourceful.Collection","doc":"A `data_source` can be another from an Ecto schema, to a module that\nintteracts with a remote API, to a list as long as there is an underlying\nmodule to support the common interfaces. (For now, that's just Ecto.)","ref":"Resourceful.Collection.html#module-data-sources"},{"type":"function","title":"Resourceful.Collection.all/2","doc":"Returns a list of resources that may be filtered and sorted depending on\non options. Resources will always be paginated.\n\nArgs:\n  * `data_source`: See module overview.\n  * `opts`: Keyword list of options\n\nOptions:\n  * `filter`: See `Resourceful.Collection.Filter.call/2`\n  * `page`: Pagination options.\n  * `sort:`See `Resourceful.Collection.Sort.call/2`\n\nAdditionally, see settings for the delegated module as it may take additional\noptions.","ref":"Resourceful.Collection.html#all/2"},{"type":"function","title":"Resourceful.Collection.all_with_page_info/2","doc":"","ref":"Resourceful.Collection.html#all_with_page_info/2"},{"type":"function","title":"Resourceful.Collection.any?/2","doc":"Checks if `data_source` contains any resources.\n\nArgs:\n  * `data_source`: See module overview.\n  * `opts`: Keyword list of options\n\nOptions: See settings for the delegated module (e.g. `Resourceful.Collection.Ecto`).","ref":"Resourceful.Collection.html#any?/2"},{"type":"function","title":"Resourceful.Collection.default_page_size/0","doc":"","ref":"Resourceful.Collection.html#default_page_size/0"},{"type":"function","title":"Resourceful.Collection.filter/3","doc":"","ref":"Resourceful.Collection.html#filter/3"},{"type":"type","title":"Resourceful.Collection.name/0","doc":"","ref":"Resourceful.Collection.html#t:name/0"},{"type":"type","title":"Resourceful.Collection.page_info/0","doc":"","ref":"Resourceful.Collection.html#t:page_info/0"},{"type":"function","title":"Resourceful.Collection.page_info/2","doc":"Returns the total number of resources and pages based on `page_size` in a\n`data_source`.\n\nArgs:\n  * `data_source`: See module overview.\n  * `opts`: Keyword list of options\n\nOptions: See settings for the delegated module (e.g. `Resourceful.Collection.Ecto`).","ref":"Resourceful.Collection.html#page_info/2"},{"type":"function","title":"Resourceful.Collection.page_info/3","doc":"","ref":"Resourceful.Collection.html#page_info/3"},{"type":"function","title":"Resourceful.Collection.page_number_or_default/1","doc":"","ref":"Resourceful.Collection.html#page_number_or_default/1"},{"type":"function","title":"Resourceful.Collection.page_size_or_default/1","doc":"","ref":"Resourceful.Collection.html#page_size_or_default/1"},{"type":"function","title":"Resourceful.Collection.paginate/2","doc":"","ref":"Resourceful.Collection.html#paginate/2"},{"type":"function","title":"Resourceful.Collection.paginate/4","doc":"","ref":"Resourceful.Collection.html#paginate/4"},{"type":"function","title":"Resourceful.Collection.paginate_with_info/2","doc":"","ref":"Resourceful.Collection.html#paginate_with_info/2"},{"type":"function","title":"Resourceful.Collection.query/2","doc":"","ref":"Resourceful.Collection.html#query/2"},{"type":"type","title":"Resourceful.Collection.queryable/0","doc":"","ref":"Resourceful.Collection.html#t:queryable/0"},{"type":"function","title":"Resourceful.Collection.sort/3","doc":"","ref":"Resourceful.Collection.html#sort/3"},{"type":"function","title":"Resourceful.Collection.total/2","doc":"Returns the total number of resources in a `data_source`.\n\nArgs:\n  * `data_source`: See module overview.\n  * `opts`: Keyword list of options\n\nOptions: See settings for the delegated module (e.g. `Resourceful.Collection.Ecto`).","ref":"Resourceful.Collection.html#total/2"},{"type":"type","title":"Resourceful.Collection.with_page_info/0","doc":"","ref":"Resourceful.Collection.html#t:with_page_info/0"},{"type":"type","title":"Resourceful.Collection.with_page_info/1","doc":"","ref":"Resourceful.Collection.html#t:with_page_info/1"},{"type":"protocol","title":"Resourceful.Collection.Delegate","doc":"","ref":"Resourceful.Collection.Delegate.html"},{"type":"function","title":"Resourceful.Collection.Delegate.cast_filter/2","doc":"","ref":"Resourceful.Collection.Delegate.html#cast_filter/2"},{"type":"function","title":"Resourceful.Collection.Delegate.cast_sorter/2","doc":"","ref":"Resourceful.Collection.Delegate.html#cast_sorter/2"},{"type":"function","title":"Resourceful.Collection.Delegate.collection/1","doc":"","ref":"Resourceful.Collection.Delegate.html#collection/1"},{"type":"function","title":"Resourceful.Collection.Delegate.filters/1","doc":"","ref":"Resourceful.Collection.Delegate.html#filters/1"},{"type":"function","title":"Resourceful.Collection.Delegate.paginate/3","doc":"","ref":"Resourceful.Collection.Delegate.html#paginate/3"},{"type":"function","title":"Resourceful.Collection.Delegate.sort/2","doc":"","ref":"Resourceful.Collection.Delegate.html#sort/2"},{"type":"type","title":"Resourceful.Collection.Delegate.t/0","doc":"All the types that implement this protocol.","ref":"Resourceful.Collection.Delegate.html#t:t/0"},{"type":"module","title":"Resourceful.Collection.Ecto","doc":"","ref":"Resourceful.Collection.Ecto.html"},{"type":"function","title":"Resourceful.Collection.Ecto.all/2","doc":"","ref":"Resourceful.Collection.Ecto.html#all/2"},{"type":"function","title":"Resourceful.Collection.Ecto.any?/2","doc":"","ref":"Resourceful.Collection.Ecto.html#any?/2"},{"type":"function","title":"Resourceful.Collection.Ecto.repo/1","doc":"","ref":"Resourceful.Collection.Ecto.html#repo/1"},{"type":"function","title":"Resourceful.Collection.Ecto.total/2","doc":"","ref":"Resourceful.Collection.Ecto.html#total/2"},{"type":"module","title":"Resourceful.Collection.Ecto.Filters","doc":"Functions for converting Resourceful-style filters into Ecto-style SQL\nfilters.\n\nSee `Resourceful.Collection.Filter` for more details on filters.\n\nThere's a lot of duplication here that can, hopefully, be resolved with a\nbetter understanding of macros.","ref":"Resourceful.Collection.Ecto.Filters.html"},{"type":"function","title":"Resourceful.Collection.Ecto.Filters.contains/3","doc":"","ref":"Resourceful.Collection.Ecto.Filters.html#contains/3"},{"type":"function","title":"Resourceful.Collection.Ecto.Filters.equal/3","doc":"","ref":"Resourceful.Collection.Ecto.Filters.html#equal/3"},{"type":"function","title":"Resourceful.Collection.Ecto.Filters.exclude/3","doc":"","ref":"Resourceful.Collection.Ecto.Filters.html#exclude/3"},{"type":"function","title":"Resourceful.Collection.Ecto.Filters.greater_than/3","doc":"","ref":"Resourceful.Collection.Ecto.Filters.html#greater_than/3"},{"type":"function","title":"Resourceful.Collection.Ecto.Filters.greater_than_or_equal/3","doc":"","ref":"Resourceful.Collection.Ecto.Filters.html#greater_than_or_equal/3"},{"type":"function","title":"Resourceful.Collection.Ecto.Filters.include/3","doc":"","ref":"Resourceful.Collection.Ecto.Filters.html#include/3"},{"type":"function","title":"Resourceful.Collection.Ecto.Filters.less_than/3","doc":"","ref":"Resourceful.Collection.Ecto.Filters.html#less_than/3"},{"type":"function","title":"Resourceful.Collection.Ecto.Filters.less_than_or_equal/3","doc":"","ref":"Resourceful.Collection.Ecto.Filters.html#less_than_or_equal/3"},{"type":"function","title":"Resourceful.Collection.Ecto.Filters.not_equal/3","doc":"","ref":"Resourceful.Collection.Ecto.Filters.html#not_equal/3"},{"type":"function","title":"Resourceful.Collection.Ecto.Filters.starts_with/3","doc":"","ref":"Resourceful.Collection.Ecto.Filters.html#starts_with/3"},{"type":"module","title":"Resourceful.Collection.Filter","doc":"Provides a common interface for filtering collections. See `call/2` for use\nand examples.\n\nThis module is intended to dispatch arguments to the appropriate `Filter`\nmodule for the underlying data source.\n\nFiltering is not meant to replace and be anything even resembling feature\ncomplete with more robust querying options provided by various databases. As\nThe focus is on edge-facing APIs, generally web-based APIs, filtering is\nmeant to be much simpler and more predictable. For instance, wildcard and\nregular expression filtering are omitted specifically by default. This is\nintentional.","ref":"Resourceful.Collection.Filter.html"},{"type":"function","title":"Resourceful.Collection.Filter.call/2","doc":"Returns a data source that is filtered in accordance with `filters`.\n\nIf `data_source` is not an actual list of resources (e.g. an Ecto Queryable)\nunderlying modules should not return a list of resources, but rather a\nfiltered version of `data_source`.","ref":"Resourceful.Collection.Filter.html#call/2"},{"type":"function","title":"Args - Resourceful.Collection.Filter.call/2","doc":"* `data_source`: See `Resourceful.Collection` module overview.\n  * `filters`: A list of filters. See `cast/1` for a list of valid\n    filters.","ref":"Resourceful.Collection.Filter.html#call/2-args"},{"type":"function","title":"Resourceful.Collection.Filter.cast/1","doc":"Converts an argument into an appropriate filter parameter. A casted filter\nis a tuple of containing an atom for the field name, an atom of the function\nname that will be called by the delegated module, and the value that will\nbe used for comparison.\n\nFilter parameters can be provided as a tuple, list, or string and will be\ncasted to the appropriate format. Invalid operators and their respective\nvalues will result in an exception. Please see `valid_operator?/2` if you want\nto ensure client provided data is valid first.\n\n(Note: Should this throw an exception or should it return an :error tuple by\ndefault?)","ref":"Resourceful.Collection.Filter.html#cast/1"},{"type":"function","title":"Examples - Resourceful.Collection.Filter.cast/1","doc":"cast({:age, \"gte\", 18})\n\n  cast([\"age\", \"gte\", 18])\n\n  cast([\"age gte\", 18])","ref":"Resourceful.Collection.Filter.html#cast/1-examples"},{"type":"function","title":"Resourceful.Collection.Filter.cast!/1","doc":"","ref":"Resourceful.Collection.Filter.html#cast!/1"},{"type":"function","title":"Resourceful.Collection.Filter.cast_as_list?/1","doc":"","ref":"Resourceful.Collection.Filter.html#cast_as_list?/1"},{"type":"type","title":"Resourceful.Collection.Filter.coercible/0","doc":"","ref":"Resourceful.Collection.Filter.html#t:coercible/0"},{"type":"type","title":"Resourceful.Collection.Filter.t/0","doc":"","ref":"Resourceful.Collection.Filter.html#t:t/0"},{"type":"function","title":"Resourceful.Collection.Filter.valid_operator?/1","doc":"Checks whether or not an operator is valid.","ref":"Resourceful.Collection.Filter.html#valid_operator?/1"},{"type":"function","title":"Args - Resourceful.Collection.Filter.valid_operator?/1","doc":"* `op`: Intended operator. Valid operators are keys in `@shorthand`.","ref":"Resourceful.Collection.Filter.html#valid_operator?/1-args"},{"type":"function","title":"Resourceful.Collection.Filter.valid_operator?/2","doc":"Checks whether or not an operator is valid in conjunction with an intended\nvalue. This can be used to validate the data from a client query.","ref":"Resourceful.Collection.Filter.html#valid_operator?/2"},{"type":"function","title":"Args - Resourceful.Collection.Filter.valid_operator?/2","doc":"* `op`: See `valid_operator?/1`.\n  * `val`: The value to be used with the operator. Certain operators only work\n    on a subset of value types. For instance `sw` is only valid with strings.","ref":"Resourceful.Collection.Filter.html#valid_operator?/2-args"},{"type":"module","title":"Resourceful.Collection.List","doc":"","ref":"Resourceful.Collection.List.html"},{"type":"function","title":"Resourceful.Collection.List.all/2","doc":"","ref":"Resourceful.Collection.List.html#all/2"},{"type":"function","title":"Resourceful.Collection.List.any?/2","doc":"","ref":"Resourceful.Collection.List.html#any?/2"},{"type":"function","title":"Resourceful.Collection.List.total/2","doc":"","ref":"Resourceful.Collection.List.html#total/2"},{"type":"module","title":"Resourceful.Collection.List.Filters","doc":"","ref":"Resourceful.Collection.List.Filters.html"},{"type":"function","title":"Resourceful.Collection.List.Filters.contains/3","doc":"","ref":"Resourceful.Collection.List.Filters.html#contains/3"},{"type":"function","title":"Resourceful.Collection.List.Filters.equal/3","doc":"","ref":"Resourceful.Collection.List.Filters.html#equal/3"},{"type":"function","title":"Resourceful.Collection.List.Filters.exclude/3","doc":"","ref":"Resourceful.Collection.List.Filters.html#exclude/3"},{"type":"function","title":"Resourceful.Collection.List.Filters.greater_than/3","doc":"","ref":"Resourceful.Collection.List.Filters.html#greater_than/3"},{"type":"function","title":"Resourceful.Collection.List.Filters.greater_than_or_equal/3","doc":"","ref":"Resourceful.Collection.List.Filters.html#greater_than_or_equal/3"},{"type":"function","title":"Resourceful.Collection.List.Filters.include/3","doc":"","ref":"Resourceful.Collection.List.Filters.html#include/3"},{"type":"function","title":"Resourceful.Collection.List.Filters.less_than/3","doc":"","ref":"Resourceful.Collection.List.Filters.html#less_than/3"},{"type":"function","title":"Resourceful.Collection.List.Filters.less_than_or_equal/3","doc":"","ref":"Resourceful.Collection.List.Filters.html#less_than_or_equal/3"},{"type":"function","title":"Resourceful.Collection.List.Filters.not_equal/3","doc":"","ref":"Resourceful.Collection.List.Filters.html#not_equal/3"},{"type":"function","title":"Resourceful.Collection.List.Filters.starts_with/3","doc":"","ref":"Resourceful.Collection.List.Filters.html#starts_with/3"},{"type":"module","title":"Resourceful.Collection.List.Sort","doc":"","ref":"Resourceful.Collection.List.Sort.html"},{"type":"function","title":"Resourceful.Collection.List.Sort.asc/2","doc":"","ref":"Resourceful.Collection.List.Sort.html#asc/2"},{"type":"function","title":"Resourceful.Collection.List.Sort.call/2","doc":"","ref":"Resourceful.Collection.List.Sort.html#call/2"},{"type":"function","title":"Resourceful.Collection.List.Sort.desc/2","doc":"","ref":"Resourceful.Collection.List.Sort.html#desc/2"},{"type":"function","title":"Resourceful.Collection.List.Sort.eq/2","doc":"","ref":"Resourceful.Collection.List.Sort.html#eq/2"},{"type":"function","title":"Resourceful.Collection.List.Sort.get_val/2","doc":"","ref":"Resourceful.Collection.List.Sort.html#get_val/2"},{"type":"function","title":"Resourceful.Collection.List.Sort.to_sorter/1","doc":"","ref":"Resourceful.Collection.List.Sort.html#to_sorter/1"},{"type":"function","title":"Resourceful.Collection.List.Sort.to_sorters/2","doc":"","ref":"Resourceful.Collection.List.Sort.html#to_sorters/2"},{"type":"module","title":"Resourceful.Collection.Sort","doc":"Provides a common interface for sorting collections. See `call/2` for use and\nexamples.\n\nThis module is intended to dispatch arguments to the appropriate `Sort` module\nfor the underlying data source.","ref":"Resourceful.Collection.Sort.html"},{"type":"function","title":"Resourceful.Collection.Sort.all/1","doc":"","ref":"Resourceful.Collection.Sort.html#all/1"},{"type":"function","title":"Resourceful.Collection.Sort.call/2","doc":"Returns a data source that is sorted in accordance with `sorters`.\n\nIf `data_source` is not an actual list of resources (e.g. an Ecto Queryable)\nunderlying modules should not return a list of resources, but rather a sorted\nversion of `data_source`.","ref":"Resourceful.Collection.Sort.html#call/2"},{"type":"function","title":"Args - Resourceful.Collection.Sort.call/2","doc":"* `data_source`: See `Resourceful.Collection` module overview.\n  * `sorters`: A list or comma separated string of sort parameters. Sort\n    parameters should be the string name of a field preceded by, optionally, a\n    `+` for ascending order (the default) or a `-` for descending order or.\n    Examples of `sorters`:\n    - `\"name,-age\"`\n    - `[\"+name\", \"-age\"]`","ref":"Resourceful.Collection.Sort.html#call/2-args"},{"type":"function","title":"Resourceful.Collection.Sort.cast/1","doc":"","ref":"Resourceful.Collection.Sort.html#cast/1"},{"type":"function","title":"Resourceful.Collection.Sort.cast!/1","doc":"","ref":"Resourceful.Collection.Sort.html#cast!/1"},{"type":"type","title":"Resourceful.Collection.Sort.coercible/0","doc":"","ref":"Resourceful.Collection.Sort.html#t:coercible/0"},{"type":"type","title":"Resourceful.Collection.Sort.t/0","doc":"","ref":"Resourceful.Collection.Sort.html#t:t/0"},{"type":"module","title":"Resourceful.Error","doc":"Errors in `Resourceful` follow a few conventions. This module contains\nfunctions to help work with those conventions. Client-facing errors are\nloosely inspired by and should be easily converted to [JSON:API-style\nerrors](https://jsonapi.org/format/#errors), however they should also be\nsuitable when JSON:API isn't used at all.","ref":"Resourceful.Error.html"},{"type":"module","title":"Error Structure - Resourceful.Error","doc":"All errors returned in `Resourceful` are expected to be two element tuples\nwhere the first element is `:error`. This is a common Elixir and Erlang\nconvention, but it's strict for the purposes of this library. `Resourceful`\ngenerates and expects one of two kinds of errors:","ref":"Resourceful.Error.html#module-error-structure"},{"type":"module","title":"Basic Errors - Resourceful.Error","doc":"Basic errors are always a two element tuple where the second element is an\natom that should related to specific kind of error returned. These are meant\nfor situations where context is either easily inferred, unnecessary, or\nobvious in some other manner.\n\nExample: `{:error, :basic_err}`\n\nBasic errors that require context are often transformed into contextual errors\nby higher level functions as they have context that lower level functions do\nnot.","ref":"Resourceful.Error.html#module-basic-errors"},{"type":"module","title":"Contextual Errors - Resourceful.Error","doc":"Contextual errors are always a two element tuple where the second element is\nanother two element tuple in which the first element is an atom and the second\nelement is a map containing contextual information such as user input, data\nbeing validated, and/or the source of the error. The map's keys must be atoms.\n\nExample: `{:error, {:context_err, %{input: \"XYZ\", source: [\"email_address\"]}}`\n\nErrors outside of this format are not expected to work with these functions.\n\n#### Sources\n\nWhile not strictly required by contextual errors the `:source` key is used to\nindicate an element in a complex data structure that is responsible for a\nparticular error. It must be a list of atoms, strings, or integers used to\nnavigate a tree of data. Non-nested values should still be in the form of a\nlist as prefixing sources is common. It's common for functions generating\nerrors to be ignorant of their full context and higher level functions to\nprepend errors with their current location.\n\n#### Other Common Conventions\n\nThere are a few other keys that appear in errors regularly:\n\n* `:detail`: A human friendly description about the error. If there is\ninformation related to resolving the error, it belongs here.\n* `:input`: A text representation of the actual input given by the client. It\nshould be as close as possible to the original. (In general, `IO.inspect/1` is\nused.)\n* `:key`: Not to be confused with `:source`, a `:key` key should always be\npresent when a lookup of data is done by some sort of key and there is a\nfailure.\n* `:value`: Not to be confused with `:input`, a `:value` key\n\n**Note:** all of these keys have convenience functions as it is a very common\nconvention to create a new error with one of these keys or add one to an\nexisting error.","ref":"Resourceful.Error.html#module-contextual-errors"},{"type":"module","title":"Error Types - Resourceful.Error","doc":"Both basic and contextual errors will contain an atom describing the specific\ntype of error. These should be thought of as error codes and should be unique\nto the kinds of errors. For example, `:attribute_not_found` means that in some\ncontext, an attribute for a given resource doesn't exist. This could be an\nattempt to filter or sort. Either way, the error type remains the same. In\nboth contexts, this error means the same thing.\n\nContextual errors of a particular type should always contain at least some\nexpected keys in their context maps. For example, `:attribute_not_found`\nshould always contain a `:name` and may contain other information. More is\nusually better when it comes to errors.\n\nKeys should remain consistent in their use. `:invalid_filter_operator`, for\nexample, should always contain an `:attribute` key implying that the failure\nwas on a valid attribute whereas `:attribute_not_found` contains a `:key` key\nimplying it was never resolved to an actual attribute.","ref":"Resourceful.Error.html#module-error-types"},{"type":"function","title":"Resourceful.Error.all/2","doc":"Mostly a convenience function to use instead of `list/1` with the option to\nauto source errors as well. Additionally it will take a non-collection value\nand convert it to a list.\n\nReturns a list of errors.","ref":"Resourceful.Error.html#all/2"},{"type":"function","title":"Resourceful.Error.any?/1","doc":"Recursively checks arbitrary data structures for any basic or contextual\nerrors.","ref":"Resourceful.Error.html#any?/1"},{"type":"function","title":"Resourceful.Error.auto_source/2","doc":"Transverses an arbitrary data structure that may contain errors and prepends\n`:source` data given the error's position in the data structure using either\nan index from a list or a key from a map.\n\n**Note:** This will not work for keyword lists. In order to infer source\ninformation they must first be converted to maps.\n\nReturns input data structure with errors modified to contain `:source` in\ntheir context.","ref":"Resourceful.Error.html#auto_source/2"},{"type":"type","title":"Resourceful.Error.basic/0","doc":"","ref":"Resourceful.Error.html#t:basic/0"},{"type":"function","title":"Resourceful.Error.context/1","doc":"Extracts the context map from an error.\n\nReturns a context map.","ref":"Resourceful.Error.html#context/1"},{"type":"type","title":"Resourceful.Error.contextual/0","doc":"","ref":"Resourceful.Error.html#t:contextual/0"},{"type":"function","title":"Resourceful.Error.delete_context_key/2","doc":"Deletes `key` from an error's context map if present.\n\nReturns an error tuple.","ref":"Resourceful.Error.html#delete_context_key/2"},{"type":"function","title":"Resourceful.Error.from_changeset/1","doc":"Converts errors from an Ecto Changeset into Resourceful errors. The `type` is\ninferred from the `:validation` key as Resourceful tends to use longer names.\nRather than relying on separate input params, the `:input` is inserted from\n`data`, and `:source` is also inferred.","ref":"Resourceful.Error.html#from_changeset/1"},{"type":"function","title":"Resourceful.Error.humanize/2","doc":"Many error types should, at a minimum, have an associated `:title`. If there\nare regular context values, it should also include a `:detail` value as well.\nBoth of these keys provide extra information about the nature of the error\nand can help the client understand the particulars of the provided context.\nWhile it might not be readily obvious what `:key` means in an error, if it is\nused in `:detail` it will help the client understand the significance.\n\nUnlike the error's type itself--which realistically should serve as an error\ncode of sorts--the title should should be more human readable and able to be\nlocalized, although it should be consistent. Similarly, detail should be able\nto be localized although it can change depending on the specifics of the error\nor values in the context map.\n\nThis function handles injecting default `:title` and `:detail` items into the\ncontext map if they are available for an error type and replacing context-\nrelated bindings in messages. (See `message_with_context/2` for details.)\n\nIn the future, this is also where localization should happen.","ref":"Resourceful.Error.html#humanize/2"},{"type":"function","title":"Resourceful.Error.list/1","doc":"Transforms an arbitrary data structure that may contain errors into a single,\nflat list of those errors. Non-error values are removed. Collections are\nchecked recursively.\n\nMaps are given special treatment in that their values are checked but their\nkeys are discarded.\n\nThis format is meant to keep reading errors fairly simple and consistent at\nthe edge. Clients can rely on reading a single list of errors regardless of\nwhether transversing nested validation failures or handling more simple single\nfault situations.\n\nThis function is also designed with another convention in mind: mixing\nsuccesses and failures in a single payload. A design goal of error use in this\nlibrary is to wait until as late as possible to return errors. That way, a\nsingle request can return the totality of its failure to the client. This way,\nmany different paths can be evaluated and if there are any errors along the\nway, those errors can be returned in full.","ref":"Resourceful.Error.html#list/1"},{"type":"function","title":"Resourceful.Error.message_with_context/2","doc":"Replaces context bindings in a message with atom keys in a context map.\n\nA message of `\"Invalid input %{input}.\" would have `%{input}` replaced with\nthe value in the context map of `:input`.","ref":"Resourceful.Error.html#message_with_context/2"},{"type":"function","title":"Resourceful.Error.ok_value/1","doc":"Recursively transforms arbitrary data structures containing `:ok` tuples with\njust values. Values which are not in `:ok` tuples are left untouched.\n\nIt does not check for errors. If errors are included, they will remain in the\nstructure untouched. This function is designed to work on error free data and\nis unlikely to be used on its own but rather with `or_ok/1`.\n\nKeyword lists where `:ok` may be included with other keys won't be returned\nas probably intended. Keep this limitation in mind.\n\nReturns the input data structure with all instances of `{:ok, value}` replaced\nwith `value`.","ref":"Resourceful.Error.html#ok_value/1"},{"type":"function","title":"Resourceful.Error.or_ok/2","doc":"Checks an arbitrary data structure for errors and returns either the errors\nor valid data.\n\nSee `all/1`, `any?/1`, and `ok_value/1` for specific details as this function\ncombines the three into a common pattern. Return the errors if there are any\nor the validated data.\n\nReturns either a list of errors wrapped in an `:error` tuple or valid data\nwrapped in an `:ok` tuple.","ref":"Resourceful.Error.html#or_ok/2"},{"type":"type","title":"Resourceful.Error.or_type/0","doc":"","ref":"Resourceful.Error.html#t:or_type/0"},{"type":"function","title":"Resourceful.Error.prepend_source/2","doc":"Adds or prepends source context to an error. A common pattern when dealing\nwith sources in nested data structures being transversed recursively is for\nthe child structure to have no knowledge of the parent structure. Once the\nchild errors are resolved the parent can then prepend its location in the\nstructure to the child's errors.","ref":"Resourceful.Error.html#prepend_source/2"},{"type":"type","title":"Resourceful.Error.t/0","doc":"","ref":"Resourceful.Error.html#t:t/0"},{"type":"function","title":"Resourceful.Error.with_context/1","doc":"Adds a context map to an error if it lacks one, converting a basic error to a\ncontextual error. It may also take a single atom to prevent error generating\ncode from having to constantly wrap errors in an `:error` tuple.","ref":"Resourceful.Error.html#with_context/1"},{"type":"function","title":"Resourceful.Error.with_context/2","doc":"Adds the specified context as an error's context. If the error already has a\ncontext map the new context is merged.","ref":"Resourceful.Error.html#with_context/2"},{"type":"function","title":"Resourceful.Error.with_context/3","doc":"Adds a context map to an error if it lacks on and then puts the key and value\ninto that map.","ref":"Resourceful.Error.html#with_context/3"},{"type":"function","title":"Resourceful.Error.with_input/2","doc":"Convenience function to create or modify an existing error with `:input`\ncontext.","ref":"Resourceful.Error.html#with_input/2"},{"type":"function","title":"Resourceful.Error.with_key/2","doc":"Convenience function to create or modify an existing error with `:key`\ncontext.","ref":"Resourceful.Error.html#with_key/2"},{"type":"function","title":"Resourceful.Error.with_source/3","doc":"Adds source context to an error and replaces `:source` if present.","ref":"Resourceful.Error.html#with_source/3"},{"type":"module","title":"Resourceful.JSONAPI.Error","doc":"Tools for converting errors formatted in accordance with `Resourceful.Error`\ninto [JSON:API-style errors](https://jsonapi.org/format/#errors).\n\nJSON:API errors have a number of reserved top-level names:\n\n  * `code`\n  * `detail`\n  * `id`\n  * `links`\n  * `meta`\n  * `source`\n  * `status`\n  * `title`\n\nResourceful errors map to JSON:API errors as follows:\n\nAn error's `type` symbol is converted to a string for `code`. With the\nexception of `meta` and `status` the remainder of keys in an error's `context`\nare mapped to either the top-level attribute of the same name or, in the event\nthe name is not a reserved name, it will be placed in `meta` which, if\npresent, will always be a map.\n\n`status` is a bit of a special case as \"status\" in a JSON:API error always\nrefers to an HTTP status code, but it's quite possible many errors might have\na `status` attribute in their context that has nothing to do with HTTP. As\nsuch, `:http_status` may be passed either as an option or as a key in a\ncontext map.","ref":"Resourceful.JSONAPI.Error.html"},{"type":"function","title":"Resourceful.JSONAPI.Error.all/2","doc":"Takes a list of errors, or an `:error` tuple with a list as the second\nelement, and converts that list to JSON:API errors.","ref":"Resourceful.JSONAPI.Error.html#all/2"},{"type":"function","title":"Resourceful.JSONAPI.Error.meta/2","doc":"Returns a map of all non-reserved attributes from a context map.","ref":"Resourceful.JSONAPI.Error.html#meta/2"},{"type":"function","title":"Resourceful.JSONAPI.Error.parameter_source/1","doc":"","ref":"Resourceful.JSONAPI.Error.html#parameter_source/1"},{"type":"function","title":"Resourceful.JSONAPI.Error.pointer_source/1","doc":"","ref":"Resourceful.JSONAPI.Error.html#pointer_source/1"},{"type":"function","title":"Resourceful.JSONAPI.Error.source/2","doc":"Returns a JSON:API source map based on the `:source` attribute in a an error's\ncontext map.","ref":"Resourceful.JSONAPI.Error.html#source/2"},{"type":"function","title":"Resourceful.JSONAPI.Error.source_string/2","doc":"Returns a JSON:API source map. Either:\n  1. `%{\"pointer\" => \"/data/attributes/problem\"}`\n  2. `%{\"parameter\" => \"fields[resource_type]\"}`","ref":"Resourceful.JSONAPI.Error.html#source_string/2"},{"type":"function","title":"Resourceful.JSONAPI.Error.status/2","doc":"Returns the appropriate `status` attribute based on either the context map or\nan explicitly passed `:http_status` option. The value in a context takes\nprecedence. The reason for this is that the keyword will often be used in\nconjunction with `all/2` to apply a default but certain errors, when a\nsituation allows for mixed errors with statuses, will want to be set\nexplicitly apart from the default.","ref":"Resourceful.JSONAPI.Error.html#status/2"},{"type":"function","title":"Resourceful.JSONAPI.Error.to_map/2","doc":"Converts a Resourceful error into a JSON:API error map which can then be\nconverted to JSON. See module overview for details on conventions.","ref":"Resourceful.JSONAPI.Error.html#to_map/2"},{"type":"module","title":"Resourceful.JSONAPI.Fields","doc":"Functions for validating fields, primarily for use with JSON:API\n[sparse fieldsets](https://jsonapi.org/format/#fetching-sparse-fieldsets).\nFields are provided by type type_name in requests and not inferred from root or\nrelationship names. This means that if a type has multiple relationships\npointing to a single type or a self-referential relationships, these will\nbe applied to all instances of that type type_name regardless of its location\nin the graph.\n\nSince this is specific to JSON:API, field names are not converted to atoms in\nthe generation options after successful validation. There's no need since\nthese prevent any mapping from occurring and never make it to the data layer.\n\nIt's also important to note that a \"field\" is\n[specifically defined](https://jsonapi.org/format/#document-type-object-fields)\nand is a collection of attribute names and relationship names. It specifically\n_excludes_ `id` and `type` despite all identifiers sharing a common namespace.\n\nNOTE: Relationships are currently not supported.","ref":"Resourceful.JSONAPI.Fields.html"},{"type":"function","title":"Resourceful.JSONAPI.Fields.validate/2","doc":"Takes a map of fields by type type_name (e.g.\n`%{\"albums\" => [\"releaseDate\", \"title\"]}`) and validates said fields against\nthe provided type. If fields are included that are not part of a\nparticular type, errors will be returned.","ref":"Resourceful.JSONAPI.Fields.html#validate/2"},{"type":"module","title":"Resourceful.JSONAPI.Include","doc":"Functions for validating includes, primarily for use with JSON:API\n[inclusion of related resources](https://jsonapi.org/format/#fetching-includes).\n\nIncludes are just relationships names on the root type. A song, for instance,\ncould include the album and, depending on the depth settings, could even\ninclude the album's artist.","ref":"Resourceful.JSONAPI.Include.html"},{"type":"function","title":"Resourceful.JSONAPI.Include.validate/2","doc":"Validates whether a relationship may be included. A graphed relationship where\n`graph?` is true may be included.","ref":"Resourceful.JSONAPI.Include.html#validate/2"},{"type":"function","title":"Resourceful.JSONAPI.Include.validate/3","doc":"","ref":"Resourceful.JSONAPI.Include.html#validate/3"},{"type":"module","title":"Resourceful.JSONAPI.Pagination","doc":"Validates parameters provided by various pagination strategies and returns\nparamaters as expected by `Resourceful.Collection`.","ref":"Resourceful.JSONAPI.Pagination.html"},{"type":"function","title":"Resourceful.JSONAPI.Pagination.validate/2","doc":"","ref":"Resourceful.JSONAPI.Pagination.html#validate/2"},{"type":"module","title":"Resourceful.JSONAPI.Params","doc":"Functions for converting URL parameters into `Resourceful` queries.\nAdditionally validates parameters when JSON:API-specific parameters are\nprovided such as `fields`.\n\nWhile JSON:API specifically designates the format for sparse fieldsets and\nsorting, filtering and pagination is left up to the implementation. Filtering\nis build around the generic queries in Resourceful and is therefore\nopinionated in format. Pagination supports a page number and limit/offset\nstrategies.\n\nThere is currently no support for `include`.","ref":"Resourceful.JSONAPI.Params.html"},{"type":"module","title":"Comma-Separated Lists and Arrays - Resourceful.JSONAPI.Params","doc":"The JSONAPI spec shows examples of\n[sparse fieldsets](https://jsonapi.org/format/#fetching-sparse-fieldsets) and\n[sorting](https://jsonapi.org/format/#fetching-sorting) using comma-separated\nstrings to represent arrays of fields. In addition to the standard form, this\nlibrary will also accept an actual array of strings. The errors that are\nreturned will differ depending on the form--specifically, the `:input` and\n`:source` values. This is intentional behavior.\n\nFor example, `sort=-field1,field2` and `sort[]=-field1&sort[]=field2` will\nreturn identitcal results if the fields are correct for the type, however\nif `field1` is invalid the errors will look slightly different:\n\nString list:\n`{:invalid_jsonapi_field, %{input: \"field1,field2\", key: \"field1\", source: [\"sort\"]}}`\n\nArray:\n`{:invalid_jsonapi_field, %{input: \"field1\", key: \"field1\", source: [\"sort\", 0]}}`","ref":"Resourceful.JSONAPI.Params.html#module-comma-separated-lists-and-arrays"},{"type":"function","title":"Resourceful.JSONAPI.Params.split_string_list/1","doc":"","ref":"Resourceful.JSONAPI.Params.html#split_string_list/1"},{"type":"function","title":"Resourceful.JSONAPI.Params.validate/3","doc":"","ref":"Resourceful.JSONAPI.Params.html#validate/3"},{"type":"function","title":"Resourceful.JSONAPI.Params.validate_fields/2","doc":"","ref":"Resourceful.JSONAPI.Params.html#validate_fields/2"},{"type":"function","title":"Resourceful.JSONAPI.Params.validate_filter/2","doc":"","ref":"Resourceful.JSONAPI.Params.html#validate_filter/2"},{"type":"function","title":"Resourceful.JSONAPI.Params.validate_include/2","doc":"","ref":"Resourceful.JSONAPI.Params.html#validate_include/2"},{"type":"function","title":"Resourceful.JSONAPI.Params.validate_page/2","doc":"","ref":"Resourceful.JSONAPI.Params.html#validate_page/2"},{"type":"function","title":"Resourceful.JSONAPI.Params.validate_sort/3","doc":"","ref":"Resourceful.JSONAPI.Params.html#validate_sort/3"},{"type":"module","title":"Resourceful.Registry","doc":"","ref":"Resourceful.Registry.html"},{"type":"macro","title":"Resourceful.Registry.__using__/1","doc":"Instances of `Resourceful.Type` are intended to be used in conjunction with a\nregistry in most circumstances. The application, and even the client, will\nlikely understand a resource type by its string name/identifier. Types\nthemselves, when associated with a registry, will be able to reference each\nother as well, which forms the basis for relationships.\n\nA module using the `Registry` behaviour becomes a key/value store.\n`defresourcefultype/1` allows the types to be evaluated entirely at compile\ntime.","ref":"Resourceful.Registry.html#__using__/1"},{"type":"function","title":"Resourceful.Registry.build_field_graph/2","doc":"Builds a field graph for a `Resourceful.Type`. Since types have a `max_depth`,\nall possible graphed fields can be computed and cached at compile time when\nusing a registry. This allows nested fields to be treated like local fields in\nthe sense that they are available in a flat map.\n\nFor example, a song type would have a `title` field. Once graphed, it would\nalso have an `album.title` field. If the depth was set to 2, access to a field\nlike `album.artist.name` would also be available.\n\nThis prevents a lot of recursion logic from being applied at every lookup and\nby instecting the field graph for a type it's easy to see all of the possible\nmappings.\n\nGraphed fields are wrapped in a `Resourceful.Type.GraphedField` struct which\ncontains relational information about the field in addition to the field data\nitself.\n\nSee `Resourceful.Type.max_depth/2` for information about what is intended to\nbe included in a field graph based on the depth setting.","ref":"Resourceful.Registry.html#build_field_graph/2"},{"type":"function","title":"Resourceful.Registry.do_build_field_graph/7","doc":"","ref":"Resourceful.Registry.html#do_build_field_graph/7"},{"type":"function","title":"Resourceful.Registry.fetch/2","doc":"","ref":"Resourceful.Registry.html#fetch/2"},{"type":"function","title":"Resourceful.Registry.fetch!/2","doc":"","ref":"Resourceful.Registry.html#fetch!/2"},{"type":"function","title":"Resourceful.Registry.fetch_field_graph/2","doc":"","ref":"Resourceful.Registry.html#fetch_field_graph/2"},{"type":"function","title":"Resourceful.Registry.fetch_field_graph!/2","doc":"","ref":"Resourceful.Registry.html#fetch_field_graph!/2"},{"type":"function","title":"Resourceful.Registry.maybe_put_name/2","doc":"A name can be optionally passed to the `type/2` macro. If provided, this name\nwill override the name of the resource created in provided block.","ref":"Resourceful.Registry.html#maybe_put_name/2"},{"type":"macro","title":"Resourceful.Registry.type/2","doc":"Assigns the resource specified in the `block` and makes it part of the\nregistry. If `name` is provided, it will rename the resource and use that\n`name` as the key.\n\nIf `block` does not result in a `Resourceful.Type` an exception will be\nraised.","ref":"Resourceful.Registry.html#type/2"},{"type":"function","title":"Resourceful.Registry.validate_type!/2","doc":"Ensures a value is a `Resourceful.Type` and that no type of the same name\nexists in the map. Raises an exception if both conditions are not met.","ref":"Resourceful.Registry.html#validate_type!/2"},{"type":"module","title":"Resourceful.Type","doc":"`Resourceful.Type` is a struct and set of functions for representing and\nmapping internal data structures to data structures more appropriate for edge\nclients (e.g. API clients). As a result, field names are _always_ strings and\nnot atoms.\n\nIn addition to mapping data field names, it validates that client\nrepresentations conform to various constraints set by the type. These include\ntransversing field graphs, limiting which fields can be queried, and how deep\ndown the graph queries can go.\n\nThe naming conventions and some of design philosophy is geared heavily toward\nAPIs over HTTP and [JSON:API specification](https://jsonapi.org/). However,\nthere is nothing JSON-API specific about types.","ref":"Resourceful.Type.html"},{"type":"module","title":"Fields - Resourceful.Type","doc":"A \"field\" refers to an attribute or a relationship on a given type. These\nshare a common namespace and in some respects can be treated interchangeably.\n\nThere is a distinction between \"local\" fields and \"query\" fields.\n\nLocal fields are those which are directly on the current type. For example, a\ntype of album may have local attributes such as a title and release date and\nlocal relationships such as artist and songs.\n\nQuery fields are a combination of local fields and fields anywhere in the\nresource graph. So, in the above example, query fields would include something\nlike an album's title and the related artist's name.","ref":"Resourceful.Type.html#module-fields"},{"type":"module","title":"Relationships and Registries - Resourceful.Type","doc":"In order to use relationships, a type must be included in a\n`Resourceful.Registry` and, in general, types are meant to be used in\nconjunction with a registry. In most functions dealing with relationships and\nrelated types, a type's `name` (just a string) is used rather than passing\na type struct. The struct itself will be looked up from the registry.","ref":"Resourceful.Type.html#module-relationships-and-registries"},{"type":"module","title":"Queries - Resourceful.Type","doc":"The term \"query\" is used to refer to filtering and sorting collections of\nresources. Since queries ultimately work on attributes, fields eligible to be\nqueried must be attributes. You could sort songs by an album's title but you\nwouldn't reasonably sort them by an album resource.\n\nFields given for a query can be represented as a list of strings or as a dot\nseparated string. So, when looking at a song, the artist's name could be\naccessed through `\"album.artist.name\"` or `[\"album\", \"artist\", \"name\"]`. As\nwith many things related to types, string input from API sources is going to\nbe the most common form of input.\n\n## \"Root\" Types\n\nResource graphs are put together from the perspective of a \"root\" type. Any\ntype can be a root type. In the example of an API, if you were looking at an\nalbum, it would be the root with its songs and artist further down the graph.","ref":"Resourceful.Type.html#module-queries"},{"type":"module","title":"Building Types - Resourceful.Type","doc":"In addition to functions that actually do something with types, there are a\nnumber of functions used for transforming types such as `max_depth/2`. As\ntypes are designed with registries in mind, types can be built at compile-time\nusing transformation functions in a manner that may be easier to read than\n`new/2` with options.","ref":"Resourceful.Type.html#module-building-types"},{"type":"module","title":"Ecto Schemas - Resourceful.Type","doc":"There is some overlap with `Ecto.Schema`. In fact, attribute types use the\nsame type system. While schemas can be used for edge data, primarily when\ncoupled with change sets, types are more specifically tailored to the task.\nTypes, combined with `Resourceful.Collection` can be combined to construct a\nqueryable API with concerns that are specific to working with the edge.\nThe query format is specifically limited for this purpose.","ref":"Resourceful.Type.html#module-ecto-schemas"},{"type":"function","title":"Resourceful.Type.attribute_names/1","doc":"Returns a list of the name of all attribute fields.","ref":"Resourceful.Type.html#attribute_names/1"},{"type":"function","title":"Resourceful.Type.cache/3","doc":"Sets a key in the `cache` map. Because types generally intended to be static\nat compile time, it can make sense to cache certain values and have functions\nlook for cached values in the cache map.\n\nFor instance, `finalize/1` creates a `MapSet` for `related_types` which\n`related_types/1` will use instead of computed the `MapSet`.\n\nCaches are not meant to be memoized, rather set on a type once it is\nconsidered complete.","ref":"Resourceful.Type.html#cache/3"},{"type":"function","title":"Resourceful.Type.fetch_attribute/2","doc":"Fetches a local attribute or, if a registry is set, a graphed attribute.","ref":"Resourceful.Type.html#fetch_attribute/2"},{"type":"function","title":"Resourceful.Type.fetch_field/3","doc":"Fetches a local field or, if a registry is set, a graphed field.","ref":"Resourceful.Type.html#fetch_field/3"},{"type":"function","title":"Resourceful.Type.fetch_field!/2","doc":"Same as `fetch_field/2` but raises `FieldError` if the field isn't present.","ref":"Resourceful.Type.html#fetch_field!/2"},{"type":"function","title":"Resourceful.Type.fetch_graphed_field/3","doc":"Fetches a field with related graph data using the resource's field graphs.\n\nUnless you have a specific reason for fetching only graphed fields, use\n`fetch_field/3` instead.","ref":"Resourceful.Type.html#fetch_graphed_field/3"},{"type":"function","title":"Resourceful.Type.fetch_graphed_field!/2","doc":"Same as `fetch_graphed_field/2` but raises `FieldError` if the graphed field\nisn't present.\n\nUnless you have a specific reason for fetching only graphed fields, use\n`fetch_field!/3` instead.","ref":"Resourceful.Type.html#fetch_graphed_field!/2"},{"type":"function","title":"Resourceful.Type.fetch_local_field/3","doc":"Fetches a local field by name.\n\nUnless you have a specific reason for fetching local fields, use\n`fetch_field/3` instead.","ref":"Resourceful.Type.html#fetch_local_field/3"},{"type":"function","title":"Resourceful.Type.fetch_local_field!/3","doc":"Same as `fetch_local_field/2` but raises `FieldError` if the local field isn't\npresent.\n\nUnless you have a specific reason for fetching local fields, use\n`fetch_field/3` instead.","ref":"Resourceful.Type.html#fetch_local_field!/3"},{"type":"function","title":"Resourceful.Type.fetch_related_type/2","doc":"Fetches another type by name from a type's registry.","ref":"Resourceful.Type.html#fetch_related_type/2"},{"type":"function","title":"Resourceful.Type.fetch_relationship/2","doc":"Fetches a local relationship or, if a registry is set, a graphed relationship.","ref":"Resourceful.Type.html#fetch_relationship/2"},{"type":"type","title":"Resourceful.Type.field/0","doc":"A field is an attribute or a relationship. They share the same namespace\nwithin a type.","ref":"Resourceful.Type.html#t:field/0"},{"type":"type","title":"Resourceful.Type.field_graph/0","doc":"","ref":"Resourceful.Type.html#t:field_graph/0"},{"type":"function","title":"Resourceful.Type.field_graph/1","doc":"Fetches the field graph for a given type if the type exists and has a\nregistry.","ref":"Resourceful.Type.html#field_graph/1"},{"type":"type","title":"Resourceful.Type.field_name/0","doc":"","ref":"Resourceful.Type.html#t:field_name/0"},{"type":"function","title":"Resourceful.Type.finalize/1","doc":"","ref":"Resourceful.Type.html#finalize/1"},{"type":"function","title":"Resourceful.Type.has_local_field?/2","doc":"Checks if a type has a local field.","ref":"Resourceful.Type.html#has_local_field?/2"},{"type":"function","title":"Resourceful.Type.id/2","doc":"Sets the attribute to be used as the ID attribute for a given type. The ID\nfield has slightly special usage in that extensions will use it for both\nidentification and equality. There are also conveniences for working directly\nwith IDs such as `get_id/2`.\n\nA limitation of types is that currently composite ID fields are not supported.","ref":"Resourceful.Type.html#id/2"},{"type":"function","title":"Resourceful.Type.map_field/2","doc":"Validates and returns the mapped names from a graph","ref":"Resourceful.Type.html#map_field/2"},{"type":"function","title":"Resourceful.Type.map_id/2","doc":"Maps the ID value for a given resource. This is just shorthand for using\n`map_value/3` on whatever field is designated as the ID.","ref":"Resourceful.Type.html#map_id/2"},{"type":"function","title":"Resourceful.Type.map_value/3","doc":"Maps a value for a given field name for a resource.","ref":"Resourceful.Type.html#map_value/3"},{"type":"function","title":"Resourceful.Type.map_values/3","doc":"Takes mappable resource, a type, and a list of fields. Returns a list of\ntuples with the field name and the mapped value. This is returned instead\nof a map to preserve the order of the input list. If order is irrelevant, use\n`to_map/2` instead.","ref":"Resourceful.Type.html#map_values/3"},{"type":"function","title":"Resourceful.Type.max_depth/2","doc":"Sets `max_depth` on a type.\n\n`max_depth` is specifically a reference to the depth of relationships that\nwill be transversed. This means the default `max_depth` of `1` would expose\nall immediate relationships and their attributes.\n\nFor example, a song type with a `max_depth` of `1` would be able to graph\nthrough `album` and query against `album.title` but would not be able to\naccess `album.artist` or any of its attributes. Increasing the `max_depth` to\n`2` would expose `album.artist.name`.","ref":"Resourceful.Type.html#max_depth/2"},{"type":"function","title":"Resourceful.Type.max_filters/2","doc":"Sets `max_filters` on a type. This is the total number of filters allowed in\na single query.","ref":"Resourceful.Type.html#max_filters/2"},{"type":"function","title":"Resourceful.Type.max_sorters/2","doc":"Sets `max_sorters` on a type. This is the total number of sorts allowed in a\nsingle query.","ref":"Resourceful.Type.html#max_sorters/2"},{"type":"function","title":"Resourceful.Type.meta/3","doc":"Adds a value to the `meta` map. Meta information is not used by types directly\nin this module. It is intended to add more information that can be used by\nextensions and other implementations. For example, JSON:API resources provide\nlinkage and describing that linkage is an appropriate use of the meta map.\n\nCached values should _not_ be put in the meta map. Though both `cache` and\n`meta` could essentially be used for the same thing, caches are expected to be\nset specially when registering a type in `Resourceful.Registry` because\n`without_cache/1` is called before finalizing a type.","ref":"Resourceful.Type.html#meta/3"},{"type":"function","title":"Resourceful.Type.name/2","doc":"Sets `name` on a type. Name must be strings and _cannot_ contain periods.\nAtoms will be automatically converted to strings.","ref":"Resourceful.Type.html#name/2"},{"type":"function","title":"Resourceful.Type.new/2","doc":"Creates a new `Resourceful.Type` with valid attributes.\n\nSee functions of the same name for more information on key functionality.\nFor fields, see `Resourceful.Type.Attribute` and\n`Resourceful.Type.Relationship`.","ref":"Resourceful.Type.html#new/2"},{"type":"function","title":"Resourceful.Type.put_field/2","doc":"Puts a new field in the `fields` map using the field's name as the\nkey. This will replace a field of the same name if present.","ref":"Resourceful.Type.html#put_field/2"},{"type":"type","title":"Resourceful.Type.queryable/0","doc":"","ref":"Resourceful.Type.html#t:queryable/0"},{"type":"function","title":"Resourceful.Type.register/2","doc":"Sets the `registry` module for a type. In general, this functional will be\ncalled by a `Resourceful.Registry` and not directly.","ref":"Resourceful.Type.html#register/2"},{"type":"function","title":"Resourceful.Type.relationship_names/1","doc":"Returns a list of the name of all relationship fields.","ref":"Resourceful.Type.html#relationship_names/1"},{"type":"function","title":"Resourceful.Type.string_name/1","doc":"Returns a name as a dot-separated string.","ref":"Resourceful.Type.html#string_name/1"},{"type":"type","title":"Resourceful.Type.t/0","doc":"","ref":"Resourceful.Type.html#t:t/0"},{"type":"function","title":"Resourceful.Type.to_map/3","doc":"Like `map_values/3` only returns a map with keys in the name of the attributes\nwith with values of the mapped values.","ref":"Resourceful.Type.html#to_map/3"},{"type":"function","title":"Resourceful.Type.validate_filter/2","doc":"Validates a single filter on an attribute.","ref":"Resourceful.Type.html#validate_filter/2"},{"type":"function","title":"Resourceful.Type.validate_map_to!/1","doc":"Returns a valid mapping name for a field. Any atom or string is valid and\nshould map to the whatever the underlying resources will look like.","ref":"Resourceful.Type.html#validate_map_to!/1"},{"type":"function","title":"Resourceful.Type.validate_max_filters/3","doc":"Validates that the max number of filters hasn't been exceeded.","ref":"Resourceful.Type.html#validate_max_filters/3"},{"type":"function","title":"Resourceful.Type.validate_max_sorters/3","doc":"Validates that the max number of sorters hasn't been exceeded.","ref":"Resourceful.Type.html#validate_max_sorters/3"},{"type":"function","title":"Resourceful.Type.validate_name!/1","doc":"Returns a valid string name for a type or field. Technically any string\nwithout a period is valid, but like most names, don't go nuts with URL\ncharacters, whitespace, etc.","ref":"Resourceful.Type.html#validate_name!/1"},{"type":"function","title":"Resourceful.Type.validate_sorter/2","doc":"Validates a single sorter on an attribute.","ref":"Resourceful.Type.html#validate_sorter/2"},{"type":"function","title":"Resourceful.Type.without_cache/1","doc":"Returns an existing type with an empty `cache` key.","ref":"Resourceful.Type.html#without_cache/1"},{"type":"module","title":"Resourceful.Type.Attribute","doc":"Attributes represent \"value\" fields for a given `Resourceful.Type`. This\ngoverns a few common operations:","ref":"Resourceful.Type.Attribute.html"},{"type":"module","title":"Casting Inputs - Resourceful.Type.Attribute","doc":"Values will often come in the form of strings from the edge. Attributes use\nEcto's typecasting to cast inputs into proper datatype or return appropriate\nerrors.","ref":"Resourceful.Type.Attribute.html#module-casting-inputs"},{"type":"module","title":"Mapping to Underlying Resources - Resourceful.Type.Attribute","doc":"Generally speaking, outside representation of resources will use strings as\nkeys on maps whereas internal structures tend to be atoms. Additionally,\ninternal structures will often use snake case whereas external structures may\ntake multiple forms (e.g. camel case or dasherized when dealing with\nJSON:API). Attributes map values to their appropriate internal keys.","ref":"Resourceful.Type.Attribute.html#module-mapping-to-underlying-resources"},{"type":"module","title":"Configuring Queries - Resourceful.Type.Attribute","doc":"APIs may choose to restrict what attributes can be filtered and sorted. For\ninstance, you make wish to only allow public queries against indexed\nattributes or none at all.\n\nThis allows the system restrict access and return meaningful errors when a\nclient attempts to query against an attribute.","ref":"Resourceful.Type.Attribute.html#module-configuring-queries"},{"type":"function","title":"Resourceful.Type.Attribute.cast/3","doc":"Casts an input into an attribute's type. If `cast_as_list` is true, it will\nwrap the attribute's type in a list. This is specifically for dealing with\nfilters that take a list of values.","ref":"Resourceful.Type.Attribute.html#cast/3"},{"type":"function","title":"Resourceful.Type.Attribute.error/3","doc":"Creates a contextual error wthe attribute's name in the context.","ref":"Resourceful.Type.Attribute.html#error/3"},{"type":"function","title":"Resourceful.Type.Attribute.filter/2","doc":"Sets the `filter?` key for an attribute. Collections cannot be filtered by an\nattribute unless this is set to `true`.","ref":"Resourceful.Type.Attribute.html#filter/2"},{"type":"function","title":"Resourceful.Type.Attribute.map_to/2","doc":"Sets the `map_to` key for an attribute. `map_to` is the key of the underlying\nmap to use in place of the attribute's actual `name`. Unlike a `name` which\ncan only be a string, this can be an atom or a string (dots allowed).","ref":"Resourceful.Type.Attribute.html#map_to/2"},{"type":"function","title":"Resourceful.Type.Attribute.name/2","doc":"Sets the name for the attribute. This is the \"edge\" name that clients will\ninteract with. It can be any string as long as it doesn't contain dots. This\nwill also serve as its key name if used in conjunction with a\n`Resourceful.Type` which is important in that names must be unique within a\ntype.","ref":"Resourceful.Type.Attribute.html#name/2"},{"type":"function","title":"Resourceful.Type.Attribute.new/3","doc":"Creates a new attribute, coerces values, and sets defaults.","ref":"Resourceful.Type.Attribute.html#new/3"},{"type":"function","title":"Resourceful.Type.Attribute.query/2","doc":"A shortcut for setting both `filter?` and `sort?` to the same value.","ref":"Resourceful.Type.Attribute.html#query/2"},{"type":"function","title":"Resourceful.Type.Attribute.sort/2","doc":"Sets the `sort?` key for an attribute. Collections cannot be sorted by an\nattribute unless this is set to `true`.","ref":"Resourceful.Type.Attribute.html#sort/2"},{"type":"function","title":"Resourceful.Type.Attribute.type/2","doc":"Sets the data type for casting. This must be an `Ecto.Type` or atom that works\nin its place such as `:string`.","ref":"Resourceful.Type.Attribute.html#type/2"},{"type":"function","title":"Resourceful.Type.Attribute.validate_filter/3","doc":"Validates a filter against the attribute and the data given. It ensures the\ndata type is correct for the operator and that the attribute allows filtering\nat all.","ref":"Resourceful.Type.Attribute.html#validate_filter/3"},{"type":"function","title":"Resourceful.Type.Attribute.validate_sorter/2","doc":"Validates a sorter against the attribute ensuring that sorting is allowed for\nthe attribute.","ref":"Resourceful.Type.Attribute.html#validate_sorter/2"},{"type":"module","title":"Resourceful.Type.Builders","doc":"Functions for import in `Resourceful.Registry` for building types\nprogrammatically.","ref":"Resourceful.Type.Builders.html"},{"type":"function","title":"Resourceful.Type.Builders.attribute/4","doc":"","ref":"Resourceful.Type.Builders.html#attribute/4"},{"type":"function","title":"Resourceful.Type.Builders.has_many/3","doc":"","ref":"Resourceful.Type.Builders.html#has_many/3"},{"type":"function","title":"Resourceful.Type.Builders.has_one/3","doc":"","ref":"Resourceful.Type.Builders.html#has_one/3"},{"type":"function","title":"Resourceful.Type.Builders.relationship/4","doc":"","ref":"Resourceful.Type.Builders.html#relationship/4"},{"type":"module","title":"Resourceful.Type.Ecto","doc":"Creates a `Resourceful.Type` from an `Ecto.Schema` module. The use case\nis that internal data will be represented by the schema and client-facing data\nwill be represented by the resource definition. Additionally, field names may\nbe mapped differently to the client, such as camel case values. This can be\ndone individually or with a single function as an option.\n\nSince `Resourceful.Type` instances use the same type system as Ecto, this\nis a relatively straightforward conversion.","ref":"Resourceful.Type.Ecto.html"},{"type":"function","title":"Resourceful.Type.Ecto.attribute/3","doc":"Returns a `Resourceful.Type.Attribute` based on a field from an `Ecto.Schema`\nmodule.","ref":"Resourceful.Type.Ecto.html#attribute/3"},{"type":"function","title":"Resourceful.Type.Ecto.type_with_schema/2","doc":"Returns a `Resourceful.Type` from an `Ecto.Schema` module by inferring\nvalues from the schema.","ref":"Resourceful.Type.Ecto.html#type_with_schema/2"},{"type":"function","title":"Options - Resourceful.Type.Ecto.type_with_schema/2","doc":"For most options, a list of schema field names (atoms) will be passed in\nspecifying the type's configuration for those fields. In these cases a value\nof `true` or `:all` will result in all fields being used. For example if you\nwanted to be able to query all fields, you would pass `[query: :all]`.\n\n  * `:except` - Schema fields to be excluded from the type.\n  * `:filter` - Schema fields allowed to be filtered.\n  * `:only` - Schema fields to be included in the type.\n  * `:query` - Schema fields allowed to be queried (sorted and filtered).\n  * `:sort` - Schema fields allowed to be sorted.\n  * `:transform_names` - A single argument function that takes the field name\n    (an atom) and transforms it into either another atom or a string. A type\n    of case conversion is the most likely use case.\n\nAddionally, any options not mentioned above will be passed directly to\n`Resourceful.Type.new/2`.","ref":"Resourceful.Type.Ecto.html#type_with_schema/2-options"},{"type":"module","title":"Resourceful.Type.Ecto.Query","doc":"This module is something of hack designed to deal with the fact that Ecto does\nnot make it simple to:\n\n  1. Dynamically assigned aliases to joins. When specifying `:as` it _must_ be\n     a compile-time atom. A recent reference to this issue can be found\n     [here](https://elixirforum.com/t/build-dynamic-bindings-for-ecto-query-order-by/1638/17).\n     This was learned the hard way. This is especially frustrating because\n     the aside from assignment, the aliases can be referenced dynamically\n     throughout the rest of the query DSL with a `^`.\n  2. Preload joins if a join is already present and handle join introspection\n     in general.\n\nThe easiest way to solve this was to manipulate the struct because there's\nnothing magical about aliases. They're just a named reference to a positional\nbinding. Preloads operate similarly. A tree of tuples and keyword lists\ndefines which associations should be preloaded.\n\nJoin introspection is also important so fields can be added to a query in an\nad-hoc manner without having to care whether the query contains joins or not.","ref":"Resourceful.Type.Ecto.Query.html"},{"type":"module","title":"A Note About Intended Use Cases - Resourceful.Type.Ecto.Query","doc":"It's important to remember that unless you go out of your way to mess with\ndata structures in fields (I say this because this module is going out of its\nway to mess with data structures) relationships that support inclusion must\nfollow a one-to-one path from start to finish.\n\nSee `Resourceful.Type.Relationship` for a broader explanation on this design\ndecision.","ref":"Resourceful.Type.Ecto.Query.html#module-a-note-about-intended-use-cases"},{"type":"module","title":"Is this a good idea? - Resourceful.Type.Ecto.Query","doc":"It's certainly possible the underlying `Ecto.Query` structs change. This sort\nof manipulation is effectively using a private API. Hopefully getting proper\nsupport for this behavior is doable.\n\nAdditionally, it's possible to handle some (and maybe all) of this using\nmacros. However, that ultimately seemed every more convoluted and confusing.\nAt least this is mostly simple recursion.\n\nWhat it does do is solve the problem it needed to solve.","ref":"Resourceful.Type.Ecto.Query.html#module-is-this-a-good-idea"},{"type":"function","title":"Resourceful.Type.Ecto.Query.include_field/3","doc":"Including a field does two things:\n\n1. It automatically joins any necessary relationships (see `join_field/3`).\n2. It preloads said relationships.\n\nThis allows a single query to bring back all of the data and also allows\nfiltering and sorting to work on related attributes, not just those of the\nroot type.\n\nFor reference, an `Ecto.Query` stores preload instructions meant to happen\nwith joins in the `:assocs` key in the form of a tree of keyword lists and\ntuples.\n\nA single join looks like this: `[ : { , []}]` The tuple\ncontains the position of the binging for the related join and a list of any\nchild joins which would be in the same form as the parent.\n\nIn the song/album/artist example this could look like the following:\n`[album: {1, [artist: {2, []}]}]`.","ref":"Resourceful.Type.Ecto.Query.html#include_field/3"},{"type":"function","title":"Resourceful.Type.Ecto.Query.join_field/2","doc":"Joining a field joins all associations connected to all relationships in the\nfield's graph. For example, if viewing a song and the field\n`album.artist.name` is joined, two relationships will be joined: the song's\n`album`, and the album's `artist`.\n\nThe join will be given an alias of the full relationship name. So, the album\nwill be aliases as `album` and the artist will be aliased as `album.artist`.\n\nIf those joins have already been made, the queryable will remain unchanged.\n\nFields resolving to attributes are ignored, but if they are children of a\nrelationship, the relationship will be included.","ref":"Resourceful.Type.Ecto.Query.html#join_field/2"},{"type":"function","title":"Resourceful.Type.Ecto.Query.join_field/3","doc":"Like `join_field/2` except it takes a type and a field name rather than the\ngraphed field directly.","ref":"Resourceful.Type.Ecto.Query.html#join_field/3"},{"type":"module","title":"Resourceful.Type.GraphedField","doc":"A graphed field is a field (an attribute or a relationship) bundled with graph\ndata dictating how it is to be mapped in a graph from the perspective of a\ntype.\n\nFor example, while the attribute `title` on an album will always be the same\nvalue. However, when that attribute is viewed from the perspective of a song\nor an artist graph information needs to be included. On it's own the attribute\nmight map to `:title` but from a song it would map to `[:album, :title]`.\n\nThe `query_alias` is used for Ecto to idenify a join with the `:as` option\nused.","ref":"Resourceful.Type.GraphedField.html"},{"type":"function","title":"Resourceful.Type.GraphedField.new/4","doc":"Creates a new graphed field.\n\nThis function will almost never be called directly but rather as part of\n`Resourceful.Registry.build_field_graph/2`.","ref":"Resourceful.Type.GraphedField.html#new/4"},{"type":"module","title":"Resourceful.Type.Relationship","doc":"Relationships come in one of two types: `:one` or `:many`. Things like\nforeign keys and how the relationships map are up to the underlying data\nsource. For the purposes of mapping things in `Resourceful`, it simply needs\nto understand whether it's working with a single thing or multiple things.\n\nA natural opinion of relationships is that graphing is simply not allowed on\n`:many` relationships. What this means is that you can only do graphed filters\nand sorts against `:one` relationships.\n\nFor example, a song can sort and filter on an album and its artist because a\nsong has one album which has one artist. The reverse is not possible because\nan artist has many albums which have many songs. Sorting and filtering on\nrelationships  makes sense when data can be represented as a table. In\nsituations where it's a tree, multiple queries are necessary and the client is\nresponsible for putting the data together.\n\nIt makes sense to filter and sort a song by an album or artist's attribute. It\ndoes not make sense to sort an artist by a song's attribute.","ref":"Resourceful.Type.Relationship.html"},{"type":"function","title":"Resourceful.Type.Relationship.name/2","doc":"Sets the name for the relationship. This is the \"edge\" name that clients will\ninteract with. It can be any string as long as it doesn't contain dots. This\nwill also serve as its key name if used in conjunction with a\n`Resourceful.Type` which is important in that names must be unique within a\ntype.","ref":"Resourceful.Type.Relationship.html#name/2"},{"type":"function","title":"Resourceful.Type.Relationship.new/3","doc":"Creates a new relationship, coerces values, and sets defaults.","ref":"Resourceful.Type.Relationship.html#new/3"},{"type":"type","title":"Resourceful.Type.Relationship.type/0","doc":"","ref":"Resourceful.Type.Relationship.html#t:type/0"},{"type":"module","title":"Resourceful.Util","doc":"Extra utility functions. These are for miscellaneous shared functions that\ndon't really fit with any other module but are shared across multiple modules.","ref":"Resourceful.Util.html"},{"type":"function","title":"Resourceful.Util.except_or_only!/2","doc":"Allows `:except` or `:only` options to be set in a keyword set of options. The\noptions and the set are given as arguments and, depending on the options, a\nsubset (or the set itself) will be returned.\n\nAn exception will be raised if invalid arguments are passed or if both\n`:except` and `:only` are passed.","ref":"Resourceful.Util.html#except_or_only!/2"},{"type":"exception","title":"Resourceful.Collection.Ecto.NoRepoError","doc":"","ref":"Resourceful.Collection.Ecto.NoRepoError.html"},{"type":"exception","title":"Resourceful.Registry.DuplicateTypeNameError","doc":"","ref":"Resourceful.Registry.DuplicateTypeNameError.html"},{"type":"exception","title":"Resourceful.Registry.InvalidType","doc":"","ref":"Resourceful.Registry.InvalidType.html"},{"type":"exception","title":"Resourceful.Registry.NotRegisteredError","doc":"","ref":"Resourceful.Registry.NotRegisteredError.html"},{"type":"exception","title":"Resourceful.Type.FieldError","doc":"","ref":"Resourceful.Type.FieldError.html"},{"type":"exception","title":"Resourceful.Type.InvalidMapTo","doc":"","ref":"Resourceful.Type.InvalidMapTo.html"},{"type":"exception","title":"Resourceful.Type.InvalidName","doc":"","ref":"Resourceful.Type.InvalidName.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}